#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

using Syncfusion.DLS;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace EssentialDocIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "DOC";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new MS Word document being generated using Essential DocIO.  At the end of the document generation, an option will be provided to view the generated MS Word file. Please note that you need to have an MS Word file viewer installed in order to view the generated Word file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "Essential DocIO Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());			
		}

        private WordDocument document = null;
        private WordDocument Document
        {
            get
            {
                return document;
            }
            set
            {
                document = value;
            }
        }

        // Get custom properties from document.
        public List<string> Custom_Properties
        {
            get
            {
                List<string> Cus_Properties = new List<string>();
                for (int i = 0; i < Document.CustomDocumentProperties.Count; i++ )
                {
                    Cus_Properties.Add( document.CustomDocumentProperties[i].ToString());
                }
                return Cus_Properties;
            }
        }


		private void button1_Click(object sender, System.EventArgs e)
		{
			//A new document is created.
			document = new WordDocument();
			
			//Adding a section to the document.
			IWSection section = document.AddSection();
			
			//Adding a paragraph to the section.			
			IWParagraph paragraph = section.AddParagraph();
			
			//Setting document Properties
			document.BuiltinDocumentProperties.Author = "Essential DocIO";
			document.BuiltinDocumentProperties.ApplicationName = "Essential DocIO";
			document.BuiltinDocumentProperties.Category = "Document Generator";
			document.BuiltinDocumentProperties.Comments = "This document was generated using Essential DocIO";
			document.BuiltinDocumentProperties.Company = "Syncfusion Inc";
			document.BuiltinDocumentProperties.Subject = "Native Word Generator";
			document.BuiltinDocumentProperties.Keywords = "Syncfusion";
			document.BuiltinDocumentProperties.Manager = "Sync Manager";
			document.BuiltinDocumentProperties.Title = "Essential DocIO";
						
			//Add a custom document Property			
			document.CustomDocumentProperties.Add ( "My_Doc_Date" , DateTime.Today );	
			document.CustomDocumentProperties.Add ( "My_Doc" , true );						
			document.CustomDocumentProperties.Add ( "My_ID" , 1031 );						
			document.CustomDocumentProperties.Add ( "My_Comment" , "Essential DocIO" );

            // Store the custom properties to string builder.
            StringBuilder sb = new StringBuilder();
            foreach (string cus_pro in Custom_Properties)
            {
                sb.Append(cus_pro);
                sb.Append(System.Environment.NewLine);
            }

            // Displays the list of custom properties to Message box.
            MessageBox.Show("This document contains " + Custom_Properties.Count + " custom propertie(s) \n\n" + sb.ToString(), Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information);
	
			IWTextRange text = paragraph.AppendText( "Document Properties Summary Information" );
			text.CharacterFormat.FontName = "Verdana";
			text.CharacterFormat.FontSize = 16;

            section.AddParagraph();
            paragraph = section.AddParagraph();
            paragraph.AppendText("\rMy_Doc_Date : " + document.CustomDocumentProperties["My_Doc_Date"].ToString()).CharacterFormat.FontSize = 14;
            paragraph.AppendText("\rMy_Doc : " + document.CustomDocumentProperties["My_Doc"].ToString()).CharacterFormat.FontSize = 14;
            paragraph.AppendText("\rMy_ID : " + document.CustomDocumentProperties["My_ID"].ToString()).CharacterFormat.FontSize = 14;
            paragraph.AppendText("\rMy_Comment : " + document.CustomDocumentProperties["My_Comment"].ToString()).CharacterFormat.FontSize = 14;


			//Saving the document to disk.
			document.Save( "Sample.doc" , FormatType.Doc );

			// Message box confirmation to view the created document.
			if( MessageBox.Show( "Do you want to view the MS Word document?" , "Document has been created" , MessageBoxButtons.YesNo, MessageBoxIcon.Information ) == DialogResult.Yes ) 
			{
				// Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
				Process.Start( "Sample.doc" );
				// Exit
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
			
		}		
	}
}
